<?php

class GRAPHAxis {
 var $aid;
 var $title;
 var $mode;
 var $units;
 var $range;

 const MODE_STANDARD = 0;
 const MODE_LOGARITHMIC = 1;
 
 function __construct(array &$props = NULL, $aid = false) {
    if ($aid) {
	$this->aid = $aid;
	$aprop = $aid . "_axis";
    } else {
	$this->aid = isset($props["axis"])?$props["axis"]:false;
	$aprop = "axis";
    }
    
    $this->title = $props[$aprop . "_name"]?$props[$aprop . "_name"]:translate("default");
    $this->units = $props[$aprop . "_units"];
    
    if ($props[$aprop . '_mode']) {
	$mode = $props[$aprop . '_mode'];
	if (is_numeric($mode)) $this->mode = $mode;
	else {
	    $name = "DRAWAxis::MODE_" . strtoupper($mode);
	    if (defined($name)) $this->mode = constant($name);
	    else throw new ADEIException(translate("Unknown axis mode (%s) is specified", $mode));
	}
    } else {
	$this->mode = DRAWAxis::MODE_STANDARD;
    }
    
    if (($props[$aprop . "_range"])&&(preg_match("/(.+)-(.+)/", $props[$aprop . "_range"], $m))) {
	$this->range = array($m[1], $m[2]);
    } else {
	$this->range = false;
    }
 }
}

/*
class UIAxis extends GRAPHAxis {
}
*/

?>