<?php


interface DataInterface {
    public function GetData($from, $to);
}


function CopyObjectProperties(&$dst, &$src) {
    foreach ($src as $key => $value) {
	$dst->$key = $value;
    }
}


abstract class ADEICommon  extends BASICRequest {
 function GetBaseURL() {
    global $ADEI_URL;
    global $ADEI_ROOTDIR;

    if ($ADEI_URL) {
	return $ADEI_URL;
    } else if ($_SERVER['SERVER_NAME']) {
//	list($url, $query) = preg_split("/\?/", $_SERVER['REQUEST_URI'], 2);

	$ssl = $_SERVER['HTTPS'];
	if (($ssl)&&(preg_match("/^(off|false|no)$/i", $ssl))) $ssl = false;
	
	if ($ssl) {
	    $url = "https://";
	    $default_port = 443;
	} else {
	    $url = "http://";
	    $default_port = 80;
	}

	$url .= $_SERVER['SERVER_NAME'];
	
	$port = $_SERVER['SERVER_PORT'];
	if (($port)&&($port != $default_port)) {
	    $url .= ":$port";
	}
    	
	if ($_SERVER['SCRIPT_NAME']) {
	    if (preg_match("/(.*\/)(services|admin)(\/[^\/]+)?$/", $_SERVER['SCRIPT_NAME'], $m)) {
		$url .= $m[1];
	    } else if (preg_match("/(.*\/)(\/[^\/]+)?$/", $_SERVER['SCRIPT_NAME'], $m)) {
		$url .= $m[1];
	    } else {
	    	$url .= $_SERVER['SCRIPT_NAME'];
	    }
	} else {
	    $url .= "/";
	}

	return $url;
    } else {
	return "http://localhost/" .  basename($ADEI_ROOTDIR) . "/";
    }
 }

 function TransformXML($xslt, $xml) {
    $xsldoc = new DOMDocument();
    $xmldoc = new DOMDocument();

    if (($xsldoc)&&($xmldoc)) {
	if (!@$xsldoc->load($this->GetXSLTFile($xslt))) {
	    throw new ADEIException(translate("Failed to load xslt stylesheet \"%s\"", $xslt));
	}
	
	if (!@$xmldoc->load($xml)) {
	    throw new ADEIException(translate("Failed to load xml file \"%s\"", $xml));
	}
    } else {
	throw new ADEIException(translate("Failed to create DOM document"));
    }
    
    $xh = new XSLTProcessor();
    if ($xh) {
	if (!@$xh->importStylesheet($xsldoc)) {
	    throw new ADEIException(translate("Failed to process xslt stylesheet \"%s\"", $xslt));
	}
    } else {
	throw new ADEIException(translate("Failed to create XSLT processor"));
    }
	
    $res = @$xh->transformToXML($xmldoc);
    if (!$res) throw new ADEIException(translate("XSL Transformation is failed"));
    
    return $res;
 }

 static function EscapeForXML($message) {
	/* Note: htmlspecialchars will return empty string if non-unicode m
	essage is passed. */
    $msg = htmlspecialchars($message, ENT_COMPAT, "UTF-8");
    if ($msg) return $msg;
    return htmlspecialchars($message, ENT_COMPAT);
 }


}



/*
    $this->gid = $props["db_group"];
    $this->group_table = "log" . $this->gid;

	// Handle names
    $this->mask = $props["db_mask"];

    
    $this->interval_initialized = false;
    if (isset($props['interval_start'])) $this->interval_start = $props['interval_start'];
    else $this->interval_start = 0;
    if (isset($props['interval_end'])) $this->interval_end = $props['interval_end'];
    else $this->interval_end = 0;

    $this->window_initialized = false;
    if (isset($props['window_start'])) $this->window_start = $props['window_start'];
    else $this->window_start = 0;
    if (isset($props['window_size'])) $this->window_size = $props['window_size'];
    else $this->window_size = 0;


    if (!$this->connected) throw new ADEIException(_("The ZEUS database is not specified"));


 function GetWindowSize() {	
    if (!$this->window_initialized) $this->SetupWindow();
    return $this->window_size;
 }

*/    

?>