<?php
require("../adei.php");

header("Content-type: application/json");
header("Cache-Control: no-cache, must-revalidate");
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");

try {
    $req = new REQUEST();
    switch ($req->props['module']) {
     case "graph":
	if ($req->CheckData()) {

	    $req = $req->CreateDataRequest();

	    $draw = $req->CreatePlotter();
	    $draw->Create();
	    $file = $draw->Save();
	    $scale = $draw->GetScaleInfo();
	} else {
	    $draw = $req->CreateImageHelper();
	    $draw->Create();
	    $file = $draw->Save();
	    $no_data = true;
	}
     break;
     case "alarms":
	if ($req->CheckData()) {
    	    $query = $req->GetQueryString($extra = array(
		"target" => "alarms_summary",
		"time_format" => "text"
	    ));
	
    	    $info = array(
		"xml" => "services/control.php?$query",
		"xslt" => "alarms"
	    );
	}
     break;
     case "slowcontrol":
	if ($req->CheckData()) {
    	    $query = $req->GetQueryString($extra = array(
		"target" => "status",
		"time_format" => "text"
	    ));
	
    	    $info = array(
		"xml" => "services/control.php?$query",
		"xslt" => "controlinfo"
	    );
	}
     break;
     case "wiki":
        $query = $req->GetQueryString();
    	$info = array(
	    "xml" => "services/wiki.php?$query",
	    "xslt" => "wiki"
	);
     break;
    }
} catch(ADEIException $e) {
    $error = $e->getInfo();

    if (($draw)&&(($e->getCode() == ADEIException::NO_DATA)||($e->getCode() == ADEIException::NO_CACHE))) {
	if (($e->getCode() == ADEIException::NO_CACHE)&&($req->IsVirtual())) {
	    $error = "----------------";
	}
	
	try {
	    $no_data = true;
	    $draw->CreateMessage("Error", $error);
	    $file = $draw->Save();
	    $error = false;
	} catch (ADEIException $ex) {
	    $no_data = false;
	    $ex->logInfo(NULL, $draw);
	}
    } else {
	$e->logInfo(NULL, $draw?$draw:$req);	
    }
}

if ($error) {
    echo json_encode(array("error" => $error));
} else {
    if ($draw) {
	if ($no_data) {
	    echo json_encode(array(
		"module" => "graph",
		"nodata" => true,
		"draw" => 1,
		"image" => $file
	    ));
	} else {
	    echo json_encode(array_merge(array(
		"error" => 0,
		"module" => "graph",
		"draw" => 1,
		"image" => $file
	    ), $scale));
	}
    } else if ($info) {
	if (!$info['module']) $info['module'] = $req->props['module'];
	echo json_encode($info);
    } else {
	echo json_encode(array(
	    "error" => 0
	));
    }
}


?>